%Author: Shebuti Rayana
function avg = AvgKNN(data,train_ind,k)
    [m,~] = size(data);
    train = data(train_ind,:);
    test = data;
    test_ind = [1:m]';
    
    distmat = Distance(test,train);
    % sort the distances
    [sD,I] = sort(distmat,2);
    k_distance = zeros(m,k);
    
    ind1 = ismember(test_ind,train_ind);
    ind2 = ~ismember(test_ind,train_ind);
    k_distance(ind1==1,:) = sD(ind1==1,2:k+1);
    k_distance(ind2==1,:) = sD(ind2==1,1:k);
    avg = mean(k_distance,2);
end